LibreOffice: DataForm Service Reference

LibreOffice LibreOffice 7.5 SDK API Reference

Loading...
Searching...
No Matches
Public Types | Included Services | Exported Interfaces | Public Attributes | List of all members
DataForm Service Referencepublished

This service specifies a form which is connected to a database and displays the results of SQL queries. More...

Inheritance diagram for DataForm:

## Public Types
typedef sequence< string > | MasterFields
| is used for subforms and contains the names of columns of the parent form.
typedef sequence< string > | DetailFields
| is used for subforms and contains the names of the columns of the subform which are related to the master fields of the parent form.

## Included Services
service | com::sun::star::sdb::RowSet
service | com::sun::star::form::component::Form
Included Services inherited from RowSet
service | com::sun::star::sdbc::RowSet
service | com::sun::star::sdb::ResultSet
Included Services inherited from RowSet
service | com::sun::star::sdbc::ResultSet
Included Services inherited from ResultSet
service | com::sun::star::sdbcx::ResultSet
Included Services inherited from ResultSet
service | com::sun::star::sdbc::ResultSet
Included Services inherited from Form
service | com::sun::star::form::FormComponent
service | com::sun::star::form::FormComponents

## Exported Interfaces
interface | com::sun::star::form::XReset
| is used to reset controls belonging to the form, and to reset database fields to which the controls are bound
interface | com::sun::star::form::XLoadable
| used to load/unload the form
interface | com::sun::star::sdb::XCompletedExecution
| can be used to allow an interaction handler to supply missing data during a load process.
interface | com::sun::star::form::XDatabaseParameterBroadcaster
| can be used for filling parameters.
Exported Interfaces inherited from RowSet
interface | com::sun::star::sdb::XCompletedExecution
| can be used to allow an interaction handler to supply missing data during an execute process.
interface | XRowSetApproveBroadcaster
| approving of actions performed on the row set.
interface | com::sun::star::sdbc::XResultSetUpdate
| is the interface for updating row data to the database.
interface | com::sun::star::sdbcx::XDeleteRows
| is the interface for deleting more than one row, identified by its bookmark.
interface | XResultSetAccess
| creates a second result set which is based on the same data.
interface | XParametersSupplier
| gives access to the parameters contained in the SQL statement represented by the component.
Exported Interfaces inherited from RowSet
interface | XRowSet
| used to execute and to add/remove listeners.
interface | XParameters
interface | XColumnLocate
| allows locating columns whose name is known only.
Exported Interfaces inherited from ResultSet
interface | com::sun::star::lang::XComponent
| optional for implementation; controls the releasing of resources and the notification of registered listeners.
interface | XCloseable
| freeing all resources of a result set.
interface | com::sun::star::beans::XPropertySet
interface | XWarningsSupplier
| controls the chaining of warnings, which may occur on every call to the connected database.
interface | XResultSetMetaDataSupplier
| provides the access to the result set description.
interface | XResultSet
| is the interface for navigating on the rows on a result set.
interface | XResultSetUpdate
| is the interface for updating row data to the database.
interface | XRow
| is the interface for accessing the data of the current row.
interface | XColumnLocate
| is used for locating a column by its name.
interface | XRowUpdate
| is the interface for updating the data of the current row.
Exported Interfaces inherited from ResultSet
interface | com::sun::star::sdbcx::XColumnsSupplier
| access to the description and data.
Exported Interfaces inherited from ResultSet
interface | com::sun::star::util::XCancellable
| could be used for canceling the execution of SQL statements if both the DBMS and the driver support aborting of navigation commands.
interface | XRowLocate
| is the interface for navigating on the result set by unique bookmarks.
interface | XDeleteRows
| is the interface for deleting more than one row, identified by its bookmark.
Exported Interfaces inherited from Form
interface | com::sun::star::form::XForm
| identifies a component as form.
interface | com::sun::star::awt::XTabControllerModel
| This interface has to be implemented to supply the information for tab ordering and component grouping.
Exported Interfaces inherited from FormComponent
interface | com::sun::star::form::XFormComponent
| identifies the component as a candidate for being part of a form.
interface | com::sun::star::lang::XComponent
| allows life-time control of form components.
interface | com::sun::star::container::XNamed
| Each FormComponent must supply a name for identification.
interface | com::sun::star::beans::XPropertySet
| gives access to the properties.
interface | com::sun::star::io::XPersistObject
| Each FormComponent must be able to be stored into and read from a stream.
interface | com::sun::star::beans::XPropertyBag
| allows to associate arbitrary properties with the form component
Exported Interfaces inherited from XPropertyBag
interface | com::sun::star::beans::XPropertySet
interface | com::sun::star::beans::XPropertyContainer
interface | com::sun::star::beans::XPropertyAccess
Exported Interfaces inherited from FormComponents
interface | com::sun::star::container::XContainer
| allows to register listeners to be notified of changes in the container.
interface | com::sun::star::container::XNameContainer
| allows to add/remove elements by name.
interface | com::sun::star::container::XIndexContainer
| gives access to the elements by index.
interface | com::sun::star::container::XEnumerationAccess
| creates an enumeration of the elements.
interface | com::sun::star::script::XEventAttacherManager
| This interface has to be implemented to supply the scripting environment for the contained components.

## Public Attributes
com::sun::star::form::TabulatorCycle | Cycle
| returns the kind of tabulator controlling.
com::sun::star::form::NavigationBarMode | NavigationBarMode
| determines how a navigation bar for this form should act.
boolean | AllowInserts
| determines if insertions into the form's row set are allowed.
boolean | AllowUpdates
| determines if modifications of the current record of the form are allowed.
boolean | AllowDeletes
| determines if deletions of records of the form are allowed.
Public Attributes inherited from RowSet
com::sun::star::sdbc::XConnection | ActiveConnection
| is the connection generated by a DataSource or by a URL.
string | DataSourceName
| is the name of the datasource to use, this could be a named datasource or the URL of a data access component.
string | Command
| is the command which should be executed, the type of command depends on the CommandType.
long | CommandType
| is the type of the command.
string | ActiveCommand
| is the command which is currently used.
boolean | IgnoreResult
| indicates whether all results should be discarded or not.
string | Filter
| additional filter for a row set.
boolean | ApplyFilter
| indicates whether the filter should be applied or not, default is `FALSE`.
string | HavingClause
| additional having clause for the row set
string | GroupBy
| additional group by for the row set
string | Order
| is an additional sort order definition for a row set.
long | Privileges
| indicates the privileges for insert, update, and delete.
boolean | IsModified
| indicates that the current row is modified.
boolean | IsNew
| indicates that the current row is going to be inserted to the database.
long | RowCount
| contains the number of rows accessed in the data source.
boolean | IsRowCountFinal
| indicates that all rows of the row set have been counted.
string | UpdateTableName
| is the name of the table which should be updated, this is usually used for queries which relate to more than one table.
string | UpdateCatalogName
| is the name of the table catalog
string | UpdateSchemaName
| is the name of the table schema.
Public Attributes inherited from RowSet
string | DataSourceName
| is the name of a named datasource to use.
string | URL
| is the connection URL.
string | Command
| is the command which should be executed.
long | TransactionIsolation
| indicates the transaction isolation level, which should be used for the connection.
com::sun::star::container::XNameAccess | TypeMap
| is the type map that will be used for the custom mapping of SQL structured types and distinct types.
boolean | EscapeProcessing
| returns if escape processing is on or off.
long | QueryTimeOut
| retrieves the number of seconds the driver will wait for a Statement to execute.
long | MaxFieldSize
| returns the maximum number of bytes allowed for any column value.
long | MaxRows
| retrieves the maximum number of rows that a ResultSet can contain.
string | User
| determines the user for whom to open the connection.
string | Password
| determines the user for whom to open the connection.
long | ResultSetType
| determine the result set type.
Public Attributes inherited from ResultSet
string | CursorName
| defines the SQL cursor name that will be used by subsequent Statement `execute` methods.
long | ResultSetConcurrency
| retrieves the result set concurrency.
long | ResultSetType
| determines the result set type.
long | FetchDirection
| retrieves the direction for fetching rows from database tables that is the default for result sets generated from this com::sun::star::sdbcx::Statement object.
long | FetchSize
| retrieves the number of result set rows that is the default fetch size for result sets generated from this com::sun::star::sdbcx::Statement object.
Public Attributes inherited from ResultSet
boolean | IsBookmarkable
| returns if the result set supports bookmark navigation.
boolean | CanUpdateInsertedRows
| returns whether the result set supports updating of newly inserted rows.
Public Attributes inherited from FormComponent
string | Name
| the name of the component.

## Additional Inherited Members
Public Member Functions inherited from XPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValue ([in] string aPropertyName, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value of the property with the specified name.
any | getPropertyValue ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
void | addPropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener xListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XPropertyChangeListener to the specified property.
void | removePropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XPropertyChangeListener from the listener list.
void | addVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XVetoableChangeListener to the specified property with the name PropertyName.
void | removeVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XVetoableChangeListener from the listener list.
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.
Public Member Functions inherited from XResultSetMetaDataSupplier
XResultSetMetaData | getMetaData () raises (SQLException)
| retrieves the number, types, and properties of a ResultSet's columns.
Public Member Functions inherited from XResultSet
boolean | next () raises (SQLException)
| moves the cursor down one row from its current position.
boolean | isBeforeFirst () raises (SQLException)
| indicates whether the cursor is before the first row in the result set.
boolean | isAfterLast () raises (SQLException)
| indicates whether the cursor is after the last row in the result set.
boolean | isFirst () raises (SQLException)
| indicates whether the cursor is on the first row of the result set.
boolean | isLast () raises (SQLException)
| indicates whether the cursor is on the last row of the result set.
void | beforeFirst () raises (SQLException)
| moves the cursor to the front of the result set, just before the first row.
void | afterLast () raises (SQLException)
| moves the cursor to the end of the result set, just after the last row.
boolean | first () raises (SQLException)
| moves the cursor to the first row in the result set.
boolean | last () raises (SQLException)
| moves the cursor to the last row in the result set.
long | getRow () raises (SQLException)
| retrieves the current row number.
boolean | absolute ([in] long row) raises (SQLException)
| moves the cursor to the given row number in the result set.
boolean | relative ([in]long rows) raises (SQLException)
| moves the cursor a relative number of rows, either positive or negative.
boolean | previous () raises (SQLException)
| moves the cursor to the previous row in the result set.
void | refreshRow () raises (SQLException)
| refreshes the current row with its most recent value in the database.
boolean | rowUpdated () raises (SQLException)
| indicates whether the current row has been updated.
boolean | rowInserted () raises (SQLException)
| indicates whether the current row has had an insertion.
boolean | rowDeleted () raises (SQLException)
| indicates whether a row has been deleted.
com::sun::star::uno::XInterface | getStatement () raises (SQLException)
| returns the Statement that produced this com::sun::star::sdbc::ResultSet object.
Public Member Functions inherited from XRow
boolean | wasNull () raises (SQLException)
| reports whether the last column read had a value of SQL NULL.
string | getString ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a string.
boolean | getBoolean ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as boolean.
byte | getByte ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as a byte.
short | getShort ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a short.
long | getInt ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as an integer.
hyper | getLong ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as a long.
float | getFloat ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a float.
double | getDouble ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a double.
sequence< byte > | getBytes ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a byte array.
com::sun::star::util::Date | getDate ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a date object.
com::sun::star::util::Time | getTime ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a time object.
com::sun::star::util::DateTime | getTimestamp ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a datetime object.
com::sun::star::io::XInputStream | getBinaryStream ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a stream of uninterpreted bytes.
com::sun::star::io::XInputStream | getCharacterStream ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a stream of uninterpreted bytes.
any | getObject ([in]long columnIndex, [in]com::sun::star::container::XNameAccess typeMap) raises (SQLException)
| returns the value of a column in the current row as an object.
XRef | getRef ([in]long columnIndex) raises (SQLException)
| gets a REF(&lt;structured-type&gt;) column value from the current row.
XBlob | getBlob ([in]long columnIndex) raises (SQLException)
| gets a BLOB value in the current row.
XClob | getClob ([in]long columnIndex) raises (SQLException)
| gets a CLOB value in the current row of this `ResultSet` object.
XArray | getArray ([in]long columnIndex) raises (SQLException)
| gets a SQL ARRAY value from the current row of this `ResultSet` object.
Public Member Functions inherited from XColumnLocate
long | findColumn ([in]string columnName) raises (SQLException)
| maps the given ResultSet column name to its ResultSet column index.
Public Member Functions inherited from XRowSet
void | execute () raises (SQLException)
| populates a row set with data.
void | addRowSetListener ([in]XRowSetListener listener)
| adds the specified listener to receive the events "cursorMoved", "rowChanged", and "rowSetChanged".
void | removeRowSetListener ([in]XRowSetListener listener)
| removes the specified listener.
Public Member Functions inherited from XParameters
void | setNull ([in]long parameterIndex, [in]long sqlType) raises (SQLException)
| sets the designated parameter to SQL NULL.
void | setObjectNull ([in]long parameterIndex, [in]long sqlType, [in]string typeName) raises (SQLException)
| sets the designated parameter to SQL NULL.
void | setBoolean ([in]long parameterIndex, [in]boolean x) raises (SQLException)
| sets the designated parameter to a boolean value.
void | setByte ([in]long parameterIndex, [in]byte x) raises (SQLException)
| sets the designated parameter to a byte value.
void | setShort ([in]long parameterIndex, [in]short x) raises (SQLException)
| sets the designated parameter to a short value.
void | setInt ([in]long parameterIndex, [in]long x) raises (SQLException)
| sets the designated parameter to a long value.
void | setLong ([in]long parameterIndex, [in]hyper x) raises (SQLException)
| sets the designated parameter to a hyper value.
void | setFloat ([in]long parameterIndex, [in]float x) raises (SQLException)
| sets the designated parameter to a float value.
void | setDouble ([in]long parameterIndex, [in]double x) raises (SQLException)
| sets the designated parameter to a double value.
void | setString ([in]long parameterIndex, [in]string x) raises (SQLException)
| sets the designated parameter to a string value.
void | setBytes ([in]long parameterIndex, [in]sequence< byte > x) raises (SQLException)
| sets the designated parameter to a sequence of bytes.
void | setDate ([in]long parameterIndex, [in]com::sun::star::util::Date x) raises (SQLException)
| sets the designated parameter to a date value.
void | setTime ([in]long parameterIndex, [in]com::sun::star::util::Time x) raises (SQLException)
| sets the designated parameter to a time value.
void | setTimestamp ([in]long parameterIndex, [in]com::sun::star::util::DateTime x) raises (SQLException)
| sets the designated parameter to a datetime value.
void | setBinaryStream ([in]long parameterIndex, [in]com::sun::star::io::XInputStream x, [in]long length) raises (SQLException)
| sets the designated parameter to the given input stream, which will have the specified number of bytes.
void | setCharacterStream ([in]long parameterIndex, [in]com::sun::star::io::XInputStream x, [in]long length) raises (SQLException)
| sets the designated parameter to the given input stream, which will have the specified number of bytes.
void | setObject ([in]long parameterIndex, [in]any x) raises (SQLException)
| sets the value of a parameter using an any.
void | setObjectWithInfo ([in]long parameterIndex, [in]any x, [in]long targetSqlType, [in]long scale) raises (SQLException)
| set a value from the Datatype ANY for a parameter.
void | setRef ([in]long parameterIndex, [in]XRef x) raises (SQLException)
| sets a REF(&lt;structured-type&gt;) parameter.
void | setBlob ([in]long parameterIndex, [in]XBlob x) raises (SQLException)
| sets a BLOB parameter.
void | setClob ([in]long parameterIndex, [in]XClob x) raises (SQLException)
| sets a CLOB parameter.
void | setArray ([in]long parameterIndex, [in]XArray x) raises (SQLException)
| sets an Array parameter.
void | clearParameters () raises (SQLException)
| clears the current parameter values immediately.
Public Member Functions inherited from XRowLocate
any | getBookmark () raises (com::sun::star::sdbc::SQLException)
| returns the bookmark of the current row of a result set.
boolean | moveToBookmark ([in]any bookmark) raises (com::sun::star::sdbc::SQLException)
| moves the cursor to the row identified by a valid bookmark.
boolean | moveRelativeToBookmark ([in]any bookmark, [in]long rows) raises (com::sun::star::sdbc::SQLException)
| moves the cursor a relative number of rows, either positive or negative starting at a given bookmark position.
long | compareBookmarks ([in]any first, [in]any second) raises (com::sun::star::sdbc::SQLException)
| compares two bookmarks and returns an indication of their relative values.
boolean | hasOrderedBookmarks () raises (com::sun::star::sdbc::SQLException)
| determines whether the bookmarks of a result set are ordered or not.
long | hashBookmark ([in]any bookmark) raises (com::sun::star::sdbc::SQLException)
| returns the hash value for a specified bookmark.
Public Member Functions inherited from XColumnsSupplier
com::sun::star::container::XNameAccess | getColumns ()
| returns the container of columns.
Public Member Functions inherited from XCompletedExecution
void | executeWithCompletion ([in]com::sun::star::task::XInteractionHandler handler) raises (com::sun::star::sdbc::SQLException)
| completes necessary information before execution, for example parameter values.
Public Member Functions inherited from XRowSetApproveBroadcaster
void | addRowSetApproveListener ([in]XRowSetApproveListener listener)
| adds the specified listener to receive the events "approveCursorMove", "approveRowChange", and "approveRowSetChange".
void | removeRowSetApproveListener ([in]XRowSetApproveListener listener)
| removes the specified listener.
Public Member Functions inherited from XResultSetAccess
com::sun::star::sdbc::XResultSet | createResultSet () raises (com::sun::star::sdbc::SQLException)
| returns a new com::sun::star::sdbc::ResultSet based on the object.
Public Member Functions inherited from XChild
com::sun::star::uno::XInterface | getParent ()
| grants access to the object containing this content.
void | setParent ([in] com::sun::star::uno::XInterface Parent) raises ( com::sun::star::lang::NoSupportException )
| sets the parent to this object.
Public Member Functions inherited from XNamed
string | getName ()
void | setName ([in] string aName)
| sets the programmatic name of the object.
Public Member Functions inherited from XPersistObject
string | getServiceName ()
| gives the service name of the object
void | write ([in] com::sun::star::io::XObjectOutputStream OutStream) raises ( com::sun::star::io::IOException )
| writes all the persistent data of the object to the stream.
void | read ([in] com::sun::star::io::XObjectInputStream InStream) raises ( com::sun::star::io::IOException )
| reads all the persistent data of the object from the stream.
Public Member Functions inherited from XContainer
void | addContainerListener ([in] com::sun::star::container::XContainerListener xListener)
| adds the specified listener to receive events when elements are inserted or removed.
void | removeContainerListener ([in] com::sun::star::container::XContainerListener xListener)
| removes the specified listener so it does not receive any events from this container.
Public Member Functions inherited from XNameContainer
void | insertByName ([in] string aName, [in] any aElement) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::container::ElementExistException, com::sun::star::lang::WrappedTargetException )
| inserts the given element at the specified name.
void | removeByName ([in] string Name) raises ( com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
| removes the element with the specified name.
Public Member Functions inherited from XNameReplace
void | replaceByName ([in] string aName, [in] any aElement) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
| replaces the element with the specified name with the given element.
Public Member Functions inherited from XNameAccess
any | getByName ([in] string aName) raises ( com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
sequence< string > | getElementNames ()
boolean | hasByName ([in] string aName)
Public Member Functions inherited from XElementAccess
type | getElementType ()
boolean | hasElements ()
Public Member Functions inherited from XIndexContainer
void | insertByIndex ([in] long Index, [in] any Element) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::IndexOutOfBoundsException, com::sun::star::lang::WrappedTargetException )
| inserts the given element at the specified index.
void | removeByIndex ([in] long Index) raises ( com::sun::star::lang::IndexOutOfBoundsException, com::sun::star::lang::WrappedTargetException )
| removes the element at the specified index.
Public Member Functions inherited from XIndexReplace
void | replaceByIndex ([in] long Index, [in] any Element) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::IndexOutOfBoundsException, com::sun::star::lang::WrappedTargetException )
| replaces the element at the specified index with the given element.
Public Member Functions inherited from XIndexAccess
long | getCount ()
any | getByIndex ([in] long Index) raises ( com::sun::star::lang::IndexOutOfBoundsException, com::sun::star::lang::WrappedTargetException )
Public Member Functions inherited from XEnumerationAccess
com::sun::star::container::XEnumeration | createEnumeration ()
Public Member Functions inherited from XEventAttacherManager
void | registerScriptEvent ([in] long nIndex, [in] com::sun::star::script::ScriptEventDescriptor aScriptEvent) raises ( com::sun::star::lang::IllegalArgumentException )
| registers one event for an object identified by its index.
void | registerScriptEvents ([in] long nIndex, [in] sequence< com::sun::star::script::ScriptEventDescriptor > aScriptEvents) raises ( com::sun::star::lang::IllegalArgumentException )
| registers several events for an object identified by its index.
void | revokeScriptEvent ([in] long nIndex, [in] string aListenerType, [in] string aEventMethod, [in] string aRemoveListenerParam) raises ( com::sun::star::lang::IllegalArgumentException )
| revokes the registration of an event.
void | revokeScriptEvents ([in] long nIndex) raises ( com::sun::star::lang::IllegalArgumentException )
| revokes all events which are registered for the given index.
void | insertEntry ([in] long nIndex) raises ( com::sun::star::lang::IllegalArgumentException )
| creates an empty entry at the given position.
void | removeEntry ([in] long nIndex) raises ( com::sun::star::lang::IllegalArgumentException )
| removes the entry at the given position.
sequence< com::sun::star::script::ScriptEventDescriptor > | getScriptEvents ([in] long Index) raises ( com::sun::star::lang::IllegalArgumentException )
void | attach ([in] long nIndex, [in] com::sun::star::uno::XInterface xObject, [in] any aHelper) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::ServiceNotRegisteredException )
| attaches all the ScriptEvents which are registered for the given index to the given object.
void | detach ([in] long nIndex, [in] com::sun::star::uno::XInterface xObject) raises ( com::sun::star::lang::IllegalArgumentException )
| detaches all the ScriptEvents from the given object which are registered at this object for the given index.
void | addScriptListener ([in] com::sun::star::script::XScriptListener xListener) raises ( com::sun::star::lang::IllegalArgumentException )
| adds an XScriptListener that will be notified when an event takes place.
void | removeScriptListener ([in] com::sun::star::script::XScriptListener Listener) raises ( com::sun::star::lang::IllegalArgumentException )
| removes a XScriptListener from the listener list.
Public Member Functions inherited from XTabControllerModel
boolean | getGroupControl ()
| returns whether the control models are grouped together.
void | setGroupControl ([in] boolean GroupControl)
| determines if the control models are grouped together.
void | setControlModels ([in] sequence< com::sun::star::awt::XControlModel > Controls)
| sets the control models.
sequence< com::sun::star::awt::XControlModel > | getControlModels ()
| returns the control models.
void | setGroup ([in] sequence< com::sun::star::awt::XControlModel > Group, [in] string GroupName)
| sets a control model group.
long | getGroupCount ()
| returns the number of control model groups.
void | getGroup ([in] long nGroup, [out] sequence< com::sun::star::awt::XControlModel > Group, [out] string Name)
| returns a control model group.
void | getGroupByName ([in] string Name, [out] sequence< com::sun::star::awt::XControlModel > Group)
| returns a control model group by name.
Public Member Functions inherited from XReset
void | reset ()
| resets a component to some default value.
void | addResetListener ([in] com::sun::star::form::XResetListener aListener)
| adds the specified listener to receive events related to resetting the component.
void | removeResetListener ([in] com::sun::star::form::XResetListener aListener)
| removes the specified listener
Public Member Functions inherited from XLoadable
void | load ()
| loads the data.
void | unload ()
| unloads the data.
void | reload ()
| does a smart refresh of the object.
boolean | isLoaded ()
| returns if the object is in loaded state.
void | addLoadListener ([in] com::sun::star::form::XLoadListener aListener)
| adds the specified listener to receive load-related events
void | removeLoadListener ([in] com::sun::star::form::XLoadListener aListener)
| removes the specified listener.
Public Member Functions inherited from XDatabaseParameterBroadcaster
void | addParameterListener ([in] com::sun::star::form::XDatabaseParameterListener aListener)
| adds the specified listener, to allow it to fill in necessary parameter values.
void | removeParameterListener ([in] com::sun::star::form::XDatabaseParameterListener aListener)
| removes the specified listener.
Protected Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references.
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object.
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list.
Protected Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object.
void | acquire ()
| increases the reference counter by one.
void | release ()
| decreases the reference counter by one.
Protected Member Functions inherited from XCloseable
void | close () raises (SQLException)
| releases all resources connected to an object.
Protected Member Functions inherited from XPropertySet
com::sun::star::beans::XPropertySetInfo | getPropertySetInfo ()
void | setPropertyValue ([in] string aPropertyName, [in] any aValue) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the value of the property with the specified name.
any | getPropertyValue ([in] string PropertyName) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
void | addPropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener xListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XPropertyChangeListener to the specified property.
void | removePropertyChangeListener ([in] string aPropertyName, [in] com::sun::star::beans::XPropertyChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XPropertyChangeListener from the listener list.
void | addVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| adds an XVetoableChangeListener to the specified property with the name PropertyName.
void | removeVetoableChangeListener ([in] string PropertyName, [in] com::sun::star::beans::XVetoableChangeListener aListener) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::lang::WrappedTargetException )
| removes an XVetoableChangeListener from the listener list.
Protected Member Functions inherited from XWarningsSupplier
any | getWarnings () raises (SQLException)
| returns the first warning reported by calls on an object that supports the usage of warnings.
void | clearWarnings () raises (SQLException)
| clears all warnings reported for the object implementing the interface.
Protected Member Functions inherited from XResultSetMetaDataSupplier
XResultSetMetaData | getMetaData () raises (SQLException)
| retrieves the number, types, and properties of a ResultSet's columns.
Protected Member Functions inherited from XResultSet
boolean | next () raises (SQLException)
| moves the cursor down one row from its current position.
boolean | isBeforeFirst () raises (SQLException)
| indicates whether the cursor is before the first row in the result set.
boolean | isAfterLast () raises (SQLException)
| indicates whether the cursor is after the last row in the result set.
boolean | isFirst () raises (SQLException)
| indicates whether the cursor is on the first row of the result set.
boolean | isLast () raises (SQLException)
| indicates whether the cursor is on the last row of the result set.
void | beforeFirst () raises (SQLException)
| moves the cursor to the front of the result set, just before the first row.
void | afterLast () raises (SQLException)
| moves the cursor to the end of the result set, just after the last row.
boolean | first () raises (SQLException)
| moves the cursor to the first row in the result set.
boolean | last () raises (SQLException)
| moves the cursor to the last row in the result set.
long | getRow () raises (SQLException)
| retrieves the current row number.
boolean | absolute ([in] long row) raises (SQLException)
| moves the cursor to the given row number in the result set.
boolean | relative ([in]long rows) raises (SQLException)
| moves the cursor a relative number of rows, either positive or negative.
boolean | previous () raises (SQLException)
| moves the cursor to the previous row in the result set.
void | refreshRow () raises (SQLException)
| refreshes the current row with its most recent value in the database.
boolean | rowUpdated () raises (SQLException)
| indicates whether the current row has been updated.
boolean | rowInserted () raises (SQLException)
| indicates whether the current row has had an insertion.
boolean | rowDeleted () raises (SQLException)
| indicates whether a row has been deleted.
com::sun::star::uno::XInterface | getStatement () raises (SQLException)
| returns the Statement that produced this com::sun::star::sdbc::ResultSet object.
Protected Member Functions inherited from XResultSetUpdate
void | insertRow () raises (SQLException)
| inserts the contents of the insert row into the result set and the database.
void | updateRow () raises (SQLException)
| updates the underlying database with the new contents of the current row.
void | deleteRow () raises (SQLException)
| deletes the current row from the result set and the underlying database.
void | cancelRowUpdates () raises (SQLException)
| cancels the updates made to a row.
void | moveToInsertRow () raises (SQLException)
| moves the cursor to the insert row.
void | moveToCurrentRow () raises (SQLException)
| moves the cursor to the remembered cursor position, usually the current row.
Protected Member Functions inherited from XRow
boolean | wasNull () raises (SQLException)
| reports whether the last column read had a value of SQL NULL.
string | getString ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a string.
boolean | getBoolean ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as boolean.
byte | getByte ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as a byte.
short | getShort ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a short.
long | getInt ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as an integer.
hyper | getLong ([in]long columnIndex) raises (SQLException)
| get the value of a column in the current row as a long.
float | getFloat ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a float.
double | getDouble ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a double.
sequence< byte > | getBytes ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a byte array.
com::sun::star::util::Date | getDate ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a date object.
com::sun::star::util::Time | getTime ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a time object.
com::sun::star::util::DateTime | getTimestamp ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a datetime object.
com::sun::star::io::XInputStream | getBinaryStream ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a stream of uninterpreted bytes.
com::sun::star::io::XInputStream | getCharacterStream ([in]long columnIndex) raises (SQLException)
| gets the value of a column in the current row as a stream of uninterpreted bytes.
any | getObject ([in]long columnIndex, [in]com::sun::star::container::XNameAccess typeMap) raises (SQLException)
| returns the value of a column in the current row as an object.
XRef | getRef ([in]long columnIndex) raises (SQLException)
| gets a REF(&lt;structured-type&gt;) column value from the current row.
XBlob | getBlob ([in]long columnIndex) raises (SQLException)
| gets a BLOB value in the current row.
XClob | getClob ([in]long columnIndex) raises (SQLException)
| gets a CLOB value in the current row of this `ResultSet` object.
XArray | getArray ([in]long columnIndex) raises (SQLException)
| gets a SQL ARRAY value from the current row of this `ResultSet` object.
Protected Member Functions inherited from XColumnLocate
long | findColumn ([in]string columnName) raises (SQLException)
| maps the given ResultSet column name to its ResultSet column index.
Protected Member Functions inherited from XRowUpdate
void | updateNull ([in]long columnIndex) raises (SQLException)
| gives a nullable column a null value.
void | updateBoolean ([in]long columnIndex, [in]boolean x) raises (SQLException)
| updates a column with a boolean value.
void | updateByte ([in]long columnIndex, [in]byte x) raises (SQLException)
| updates a column with a byte value.
void | updateShort ([in]long columnIndex, [in]short x) raises (SQLException)
| updates a column with a short value.
void | updateInt ([in]long columnIndex, [in]long x) raises (SQLException)
| updates a column with an long value.
void | updateLong ([in]long columnIndex, [in]hyper x) raises (SQLException)
| updates a column with a hyper value.
void | updateFloat ([in]long columnIndex, [in]float x) raises (SQLException)
| updates a column with a float value.
void | updateDouble ([in]long columnIndex, [in]double x) raises (SQLException)
| updates a column with a double value.
void | updateString ([in]long columnIndex, [in]string x) raises (SQLException)
| updates a column with a string value.
void | updateBytes ([in]long columnIndex, [in]sequence< byte > x) raises (SQLException)
| updates a column with a byte array value.
void | updateDate ([in]long columnIndex, [in]com::sun::star::util::Date x) raises (SQLException)
| updates a column with a date value.
void | updateTime ([in]long columnIndex, [in]com::sun::star::util::Time x) raises (SQLException)
| updates a column with a time value.
void | updateTimestamp ([in]long columnIndex, [in]com::sun::star::util::DateTime x) raises (SQLException)
| updates a column with a timestamp value.
void | updateBinaryStream ([in]long columnIndex, [in]com::sun::star::io::XInputStream x, [in]long length) raises (SQLException)
| updates a column with a stream value.
void | updateCharacterStream ([in]long columnIndex, [in]com::sun::star::io::XInputStream x, [in]long length) raises (SQLException)
| updates a column with a stream value.
void | updateObject ([in]long columnIndex, [in]any x) raises (SQLException)
| updates a column with an object value.
void | updateNumericObject ([in]long columnIndex, [in]any x, [in]long scale) raises (SQLException)
| updates a column with an object value.
Protected Member Functions inherited from XCancellable
void | cancel ()
| cancels the current job of the object.
Protected Member Functions inherited from XRowLocate
any | getBookmark () raises (com::sun::star::sdbc::SQLException)
| returns the bookmark of the current row of a result set.
boolean | moveToBookmark ([in]any bookmark) raises (com::sun::star::sdbc::SQLException)
| moves the cursor to the row identified by a valid bookmark.
boolean | moveRelativeToBookmark ([in]any bookmark, [in]long rows) raises (com::sun::star::sdbc::SQLException)
| moves the cursor a relative number of rows, either positive or negative starting at a given bookmark position.
long | compareBookmarks ([in]any first, [in]any second) raises (com::sun::star::sdbc::SQLException)
| compares two bookmarks and returns an indication of their relative values.
boolean | hasOrderedBookmarks () raises (com::sun::star::sdbc::SQLException)
| determines whether the bookmarks of a result set are ordered or not.
long | hashBookmark ([in]any bookmark) raises (com::sun::star::sdbc::SQLException)
| returns the hash value for a specified bookmark.
Protected Member Functions inherited from XDeleteRows
sequence< long > | deleteRows ([in]sequence< any > rows) raises (com::sun::star::sdbc::SQLException)
| deletes one or more rows identified by their bookmarks.
Protected Member Functions inherited from XResultSetAccess
com::sun::star::sdbc::XResultSet | createResultSet () raises (com::sun::star::sdbc::SQLException)
| returns a new com::sun::star::sdbc::ResultSet based on the object.
Protected Member Functions inherited from XParametersSupplier
com::sun::star::container::XIndexAccess | getParameters ()
| returns the container of parameters.
Protected Member Functions inherited from XPropertyContainer
void | addProperty ([in] string Name, [in] short Attributes, [in] any DefaultValue) raises ( com::sun::star::beans::PropertyExistException, com::sun::star::beans::IllegalTypeException, com::sun::star::lang::IllegalArgumentException )
| adds a property to the object.
void | removeProperty ([in] string Name) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::NotRemoveableException )
| removes a property from the object.
Protected Member Functions inherited from XPropertyAccess
sequence< com::sun::star::beans::PropertyValue > | getPropertyValues ()
void | setPropertyValues ([in] sequence< com::sun::star::beans::PropertyValue > aProps) raises ( com::sun::star::beans::UnknownPropertyException, com::sun::star::beans::PropertyVetoException, com::sun::star::lang::IllegalArgumentException, com::sun::star::lang::WrappedTargetException )
| sets the values of given properties.

## Detailed Description

This service specifies a form which is connected to a database and displays the results of SQL queries.

It provides the possibility of adding new data records, modifying existing ones, or deleting them.

A database form is a special kind of enhanced database row set which provides all information for displaying the data and has more possibilities for configuring the data manipulation.

## Member Typedef Documentation

## ◆ DetailFields

sequence<string> DetailFields
| property

is used for subforms and contains the names of the columns of the subform which are related to the master fields of the parent form.

Entries in this sequence can either denote column names in the sub form, or parameter names.
For instance, you could base the form on the SQL statement `SELECT * FROM invoices WHERE cust_ref = :cid`, and add `cid` to the DetailFields property. In this case, the parameter will be filled from the corresponding master field.
Alternatively, you could simply base your form on the table `invoices`, and add the column name `cust_ref` to the DetailFields. In this case, and implicit filter clause `WHERE cust_ref = :<new_param_name>` will be created, and the artificial parameter will be filled from the corresponding master field.
If a string in this property denotes both a column name and a parameter name, it is undefined which way it is interpreted, but implementations of the service are required to either decide for the parameter or the column, and proceed as usual.

The columns specified herein typically represent a part of the primary key fields or their aliases of the detail form.

If the form is no sub form (e.g. its parent is not a form itself), this property is not evaluated.

## ◆ MasterFields

sequence<string> MasterFields
| property

is used for subforms and contains the names of columns of the parent form.

These columns are typically the foreign key fields of the parent form. The values of these columns are used to identify the data for the subform. Each time the parent form changes its current row, the subform requeries it's data based on the values of the master fields.

If the form is no sub form (e.g. its parent is not a form itself), this property is not evaluated.

## Exported Interfaces

## ◆ com::sun::star::form::component::Form

service com::sun::star::form::component::Form

## ◆ com::sun::star::sdb::RowSet

service com::sun::star::sdb::RowSet

## Exported Interfaces

## ◆ com::sun::star::form::XDatabaseParameterBroadcaster

interface com::sun::star::form::XDatabaseParameterBroadcaster

can be used for filling parameters.

You can add your component as com::sun::star::form::XDatabaseParameterListener to a form to get notified whenever the form needs parameter values to be filled in
In a first approach, the form tries to fill any parameters from its master-detail relation (if any). All values which can't be filled are then passed to all listeners, which can fill them by their own choice.

This is slightly changed if the form is loaded using the com::sun::star::sdb::XCompletedExecution::connectWithCompletion() method. In this case, the parameters are obtained from the interaction handler, not from the listeners

See also
  XCompletedExecution
  MasterFields
  DetailFields

## ◆ com::sun::star::form::XLoadable

interface com::sun::star::form::XLoadable

used to load/unload the form

Loading a form is basically the same as executing the underlying row set. In fact, all the functionality of this interface could be simulated by using setting some properties manually, com::sun::star::sdbc::XRowSet::execute(), moving the row set cursor and so on.

One main difference between XLoadable::load() and com::sun::star::sdbc::XRowSet::execute() is that if you use the former, the row set is positioned on the first record, while in the latter case it is position before the it.

## ◆ com::sun::star::form::XReset

interface com::sun::star::form::XReset

is used to reset controls belonging to the form, and to reset database fields to which the controls are bound

A DataForm is reset either on explicit request, or after it is moved to the insertion row.

The insertion row is a virtual row which is used to insert new records. It is reached by calling com::sun::star::sdbc::XResultSetUpdate::moveToInsertRow(). The com::sun::star::sdb::RowSet service specifies exactly which notifications happen in which order when calling com::sun::star::sdbc::XResultSetUpdate::moveToInsertRow(), and a DataForm implementation extends this with the following contract:

- After all notifications as defined in the com::sun::star::sdb::RowSet service have been sent, the DataForm resets itself, if all com::sun::star::form::XResetListeners approve this.
- After the reset happened, the com::sun::star::sdb::RowSet::IsModified property is reset to `FALSE`. This property might have been switched to `TRUE` during listener notifications, since listeners are allowed to change field values. Also, the com::sun::star::form::XReset::reset() implementations of bound control models might have modified the fields they're bound to (by filling them with default values).
- The reset listeners are notified of the completed reset operation.

## ◆ com::sun::star::sdb::XCompletedExecution

interface com::sun::star::sdb::XCompletedExecution

can be used to allow an interaction handler to supply missing data during a load process.

If data is needed during loading a form, then this is usually obtained via broadcaster-listener mechanisms. An example for this (and currently the only one) are parameter values.

However, if you use this method, you can pass an interaction handler which should supply these additional data.

See also
  com::sun::star::sdb::InteractionHandler

## Member Data Documentation

## ◆ AllowDeletes

boolean AllowDeletes
| property

determines if deletions of records of the form are allowed.

Note that this is a recommendation for user interface components displaying the form. Form implementations may decide to allow for deletions done via the API, even if the property is set to `FALSE`, but the user interface should respect the property value.

## ◆ AllowInserts

boolean AllowInserts
| property

determines if insertions into the form's row set are allowed.

Note that this is a recommendation for user interface components displaying the form. Form implementations may decide to allow for insertions done via the API, even if the property is set to `FALSE`, but the user interface should respect the property value.

## ◆ AllowUpdates

boolean AllowUpdates
| property

determines if modifications of the current record of the form are allowed.

Note that this is a recommendation for user interface components displaying the form. Form implementations may decide to allow for updates done via the API, even if the property is set to `FALSE`, but the user interface should respect the property value.

## ◆ Cycle

com::sun::star::form::TabulatorCycle Cycle
| property

returns the kind of tabulator controlling.

## ◆ NavigationBarMode

com::sun::star::form::NavigationBarMode NavigationBarMode
| property

determines how a navigation bar for this form should act.

The documentation for this service was generated from the following file:

- com/sun/star/form/component/DataForm.idl